(**
   Хȥåƥ ץ륳
   ̱¦ΰĤΥХ򰷤ץΰ.
   DB
   
   $Id: body_action.ml,v 1.2 2007/05/23 04:15:07 ogasawara Exp $
*)
(*
   Copyright (c) 2007 ogasawara@itpl.co.jp All Rights Reserved.
   
   Permission is hereby granted, free of charge, to any person obtaining
   a copy of this software and associated documentation files (the
   "Software"), to deal in the Software without restriction, including
   without limitation the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the Software, and to
   permit persons to whom the Software is furnished to do so, subject to
   the following conditions:
  
   The above copyright notice and this permission notice shall be
   included in all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,   
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*)
open Printf
open Mysql
open Base
open Body_param

(* processơ֥˿Ԥɲäơpid *)
let make_new_body db id =
  match Db.first db (sprintf "select new_process (%d) as pid;" id) with
    None -> failwith "cannot insert new process"
  | Some row -> 
      not_null int2ml @@ row ~key:"pid"

(* bugsơ֥processơ֥˿Ԥɲäơidpid *)
let make_new_page db =
  let bid =
    match Db.first db "select new_bug () as bid;" with
      None -> failwith "cannot insert new bug"
    | Some row -> 
	not_null int2ml @@ row ~key:"bid"
  in
  bid, make_new_body db bid

let sure to_str = function
    None -> ""
  | Some x -> to_str x

(* paramξ򸵤bugsơ֥idιԤprocessơ֥body_idιԤ񤭴 *)
let save db id body_id param =
  let _ =
    let sql =
      sprintf "update bugs set title = '%s' %s where id = %d" 
	(sure escape param.title)
	(match param.status with
	  None -> ""
	| Some status -> sprintf ", status = %d" (Bug.status2raw status))
	id
    in
    ignore (Mysql.exec db sql)
  in
  match body_id with
    None -> ()
  | Some body_id ->
      let sql =
	sprintf "update process set comment = '%s' where pid = %d" 
	  (sure escape param.comment)
	  body_id
      in
      ignore (Mysql.exec db sql)

(* Хκ.
   delete_bugȥɤǤϡbugsprocessξƤ *)
let delete_page db id =
  ignore (Mysql.exec db (sprintf "call delete_bug (%d);" id))
