type p_numeric = Int of int | Float of float
type p_refer = int * int
(** objects and it's relations *)
type t =
Logic of bool             (* *)
| Numeric of p_numeric      (* *)
| String of string          (* *)
| Name of string            (* *)
| Null                      (* *)
| Refer of p_refer          (* *)
| Reference of p_reference  (* *)
| Array of p_array          (* *)
| Dict of p_dict            (* *)
| Stream of p_stream        (* *)
and p_array = t list
and p_dict = (t * t) list
and p_stream = p_dict * string
and p_reference = p_refer * t