(**
   ؿ

   @author Satoshi Ogasawara, IT Planning Inc.
   @version $Id: base.ml,v 1.2 2007/05/23 03:50:20 ogasawara Exp $
*)
(*   
   Copyright (c) 2007 IT Planning inc. All Rights Reserved.

   Permission is hereby granted, free of charge, to any person obtaining
   a copy of this software and associated documentation files (the
   "Software"), to deal in the Software without restriction, including
   without limitation the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the Software, and to
   permit persons to whom the Software is furnished to do so, subject to
   the following conditions:
   
   The above copyright notice and this permission notice shall be
   included in all copies or substantial portions of the Software.
   
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*)

(** 㳰򥸥פѤ *)
exception Exit

(** ؿ *)
let ($) f g x = f (g x)
(** δؿŬ *)
let (@@) f g = f g

(** 㳰ͤªؿ. `Val x  `Err eΤɤ餫֤. *)
let maybe action = try `Val (action ()) with e -> `Err e

(** ͥƤɤ߽Ф *)
let input_all in_channel = 
  let rec input_local str =
    match maybe (fun () -> input_line in_channel) with
      `Val l -> input_local (str ^ l)
    | `Err _ -> str
  in
  input_local ""

(** ꥹȤʸˤؿ. string_of_list show (f, i, e) list ξ硢
    listƤshowʸ󲽤ʤ顢ǽ֤ȺǸˤ줾 f, i, eʸ
    ʸ֤ *)
let string_of_list show (f, i, e) lst =
  let rec loop str l = 
    match l with
      [] -> str
    | [hd] -> str ^ (show hd)
    | hd :: tl -> loop (str ^ (show hd) ^ i)  tl
  in
  f ^ (loop "" lst) ^ e
  
