(**
   Хȥåƥ ץ륳
   ̱¦ΰĤΥХ򰷤ץΰ.
   ѥ᡼
   
   $Id: body_param.ml,v 1.1 2007/05/23 04:15:38 ogasawara Ex  $
*)
(*
   Copyright (c) 2007 ogasawara@itpl.co.jp All Rights Reserved.
   
   Permission is hereby granted, free of charge, to any person obtaining
   a copy of this software and associated documentation files (the
   "Software"), to deal in the Software without restriction, including
   without limitation the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the Software, and to
   permit persons to whom the Software is furnished to do so, subject to
   the following conditions:
  
   The above copyright notice and this permission notice shall be
   included in all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,   
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*)

open Base

(* 륳ޥɤμ *)
type commands = 
    SHOW         (* ñʤɽ *)
  | NEW_PAGE     (* ڡ *)
  | NEW_BODY     (* Ⱥ *)
  | SAVE         (* DB¸ *)
  | DELETE_PAGE  (* Хκ *)
      
type t = { 
    command : commands;             (* ưޥ *)
    id : int option;                (* оݤȤbug.id *)
    title : string option;          (* ȥ *)
    status : Bug.status option;     (* Хơ *)
    body_id : int option;           (* process.pidб *)
    comment : string option;        (*  *)
  }
      
let maybe h name = 
  try
    let v = 
      h#param name 
    in
    if v <> "" then 
      Some v 
    else 
      None
  with
    _ -> None
	
let command h =
  try
    (* template/body.htmlܸ쥳ɤ򤳤Υե
       󥳡ɤ˹碌ƤʤȥޥåʤΤ *)
    match h#param "command" with
      "ХϿ" -> NEW_PAGE
    | "Ȥɲ" -> NEW_BODY
    | "ǡ¸" -> SAVE
    | "Хκ" -> DELETE_PAGE
    | _ -> SHOW
  with
    _ -> SHOW
	
let id h = 
  match maybe h "id" with
    Some i -> 
      Some (int_of_string i)
  | None -> 
      None
	
let title h = maybe h "title"

let status h = 
  try
    let v = 
      int_of_string @@ h#param "status" 
    in
    Some (Bug.raw2status v)
  with
    _ -> None
	
let body_id h = 
  match maybe h "body_id" with
    Some i -> Some (int_of_string i)
  | None -> None
	
let comment h = maybe h "comment"
    
(* CGIѥ᡼tι *)      
let parse handler = { command = command handler;
                      id = id handler;
		      title = title handler;
		      status = status handler;
		      body_id = body_id handler;
		      comment = comment handler; }
